! *******************************************************************
! *       SENDFILE send a file to the client                        *
! *-----------------------------------------------------------------*
! * Required subroutines:                  FILEERR.INC              *
! *                                        NETLNK.SR                *
! *                                                                 *
! * Dation-maks required  : FILE2                                   *
! *                                                                 *
! * Dations used:    : Alarm_out                                    *
! *                    LOGLINK    (if MAXI- or MINILOG)             *
! *-----------------------------------------------------------------*
! * Author: W. Gerth 24.03.2000                                     *
! *-----------------------------------------------------------------*
! * Last modification: 24.03.2000                                   *
! *******************************************************************

SENDFILE: PROC(CHILD FIXED,FILEINFO FILEPACK IDENT);

   DCL BUFFER(1000) CHAR(1);     ! The internal buffer
   DCL SCRATCH REF DATION INOUT ALPHIC;
   DCL FILESTATE             FIXED(15);
   DCL ILEN                  FIXED(31);  ! Incoming data len
   DCL COUNTER               FIXED(31);  ! total no of bytes

   DCL NETERROR              FIXED(15)     INIT(0);
   DCL NETST                 FIXED;
   DCL Fname REF CHAR(255);              ! For fast access only
   DCL Fnamelen FIXED;
   #IF MAXILOG 
     WRITE 'S: SENDFILE starting.' TO LOGLINK;
   #FIN;

   SCRATCH = FILEINFO.DatPTR;    ! For faster access only

   ILEN = 1 UPB BUFFER; COUNTER = 0(31);

   WHILE ILEN > 0(31) REPEAT
         ILEN = 1 UPB BUFFER;
         READ BUFFER FROM SCRATCH BY S(ILEN);
         FILESTATE:=ST(SCRATCH);
         IF ILEN > 0(31) THEN
           NETST=NETLNK(CHILD,BUFFER(1).CHAR(1),ILEN FIT 1(15),SO_WRITE,FLG_PUSH+FLG_WAIT);
           NETERROR=NETSTERR(NETST,'1'B,Alarm_out);
           IF NETERROR NE 0 THEN
             WRITE 'HTTP-USER: NETERROR in SENDFILE SO_WRITE'\0D0A\''
                   TO Alarm_out;
             #IF MAXILOG+MINILOG
               WRITE 'S: NETERROR in SENDFILE SO_WRITE.' TO LOGLINK; 
               NETERROR=NETSTERR(NETST,'1'B,LOGLINK);
             #FIN;
             ILEN = 0(31);
           FIN; /* IF NETERROR NE 0 THEN */
           COUNTER = COUNTER+ILEN;
         ELSE 
           IF FILESTATE GT 1 THEN
              #IF MAXILOG+MINILOG
               WRITE 'S: READ-Error in SENDFILE.' TO LOGLINK; 
               FileErr(FILESTATE,LOGLINK);
              #FIN;
           FIN; ! if FILESTATE ...
         FIN;  ! if ILEN > 0;
   END; ! WHILE REPEAT

! .................... Leaving Sendfile .......................
   CLOSE SCRATCH;
   FILESTATE:=ST(SCRATCH);
   IF (FILESTATE NE 0) THEN
      Fname = FILEINFO.Name; Fnamelen=LEN(Fname);
      PUT 'HTTP-USER: SENDFILE unable to close file ',Fname
          TO Alarm_out BY A,A(Fnamelen),SKIP;
      PUT 'HTTP-USER: File-error ',FILESTATE TO Alarm_out 
           BY SKIP,A,F(3);
      FileErr(FILESTATE,Alarm_out);
      #IF MAXILOG+MINILOG
        PUT 'S: SENDFILE unable to close file ',Fname
              TO LOGLINK BY A,A(Fnamelen);
        PUT 'S: File-error: ',FILESTATE TO LOGLINK  BY A,F(3);
        FileErr(FILESTATE,LOGLINK);
      #FIN; 
   FIN;   

   #IF MAXILOG 
      PUT 'S: ',COUNTER,' bytes sent.' TO 
           LOGLINK BY A,F(10),A;
      WRITE 'S: SENDFILE terminated.' TO LOGLINK;
   #FIN;! PRAEPROZESSOR-BEFEHL !

END; /*SENDFILE*/

